Fix typo in weekly bootstrap file
[csit.git] / bootstrap-vpp-verify-weekly.sh
1 #!/bin/bash
2 # Copyright (c) 2016 Cisco and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -x
16
17 cat /etc/hostname
18 cat /etc/hosts
19
20 VIRL_SERVERS=("10.30.51.28" "10.30.51.29" "10.30.51.30")
21 VIRL_SERVER=""
22
23 VIRL_USERNAME=jenkins-in
24 VIRL_PKEY=priv_key
25 VIRL_SERVER_STATUS_FILE="status"
26 VIRL_SERVER_EXPECTED_STATUS="PRODUCTION"
27
28 SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
29
30 if [ -f "/etc/redhat-release" ]; then
31     DISTRO="CENTOS"
32     sudo yum install -y python-devel python-virtualenv
33     VIRL_TOPOLOGY=$(cat ${SCRIPT_DIR}/VIRL_TOPOLOGY_CENTOS)
34     VIRL_RELEASE=$(cat ${SCRIPT_DIR}/VIRL_RELEASE_CENTOS)
35 else
36     DISTRO="UBUNTU"
37     export DEBIAN_FRONTEND=noninteractive
38     sudo apt-get -y update
39     sudo apt-get -y install libpython2.7-dev python-virtualenv
40     VIRL_TOPOLOGY=$(cat ${SCRIPT_DIR}/VIRL_TOPOLOGY_UBUNTU)
41     VIRL_RELEASE=$(cat ${SCRIPT_DIR}/VIRL_RELEASE_UBUNTU)
42 fi
43
44 SSH_OPTIONS="-i ${VIRL_PKEY} -o StrictHostKeyChecking=no -o UserKnownHostsFile=/dev/null -o BatchMode=yes -o LogLevel=error"
45
46 function ssh_do() {
47     echo
48     echo "### "  ssh $@
49     ssh ${SSH_OPTIONS} $@
50 }
51
52 rm -f ${VIRL_PKEY}
53 cat > ${VIRL_PKEY} <<EOF
54 -----BEGIN RSA PRIVATE KEY-----
55 MIIEpQIBAAKCAQEA+IHXq87GcqMR1C47rzx6Cbip5Ghq8pKrbqKrP5Nf41HcYrT6
56 GOXl9nFWKsMOzIlIn+8y7Il27eZh7csQGApbg8QLiHMtcYEmWNzKZpkqg4nuAPxX
57 VXwlKgnKX902SrET9Gp9TDayiHtCRWVfrlPPPSA0UEXW6BjLN/uHJ+W/Xzrrab+9
58 asBVa05vT2W6n0KJ66zfCaeDM912mQ6SttscAwFoWDmdHlegiVqrlIG2ABxOvxxz
59 L3dM3iSmlmQlzv9bThjo+nI4KFYh6m5wrZmAo5r/4q9CIJc21HVnTqkGOWJIZz6J
60 73lePJVSq5gYqaoGw3swFEA/MDkOx7baWKSoLQIDAQABAoIBAQCNBeolNp+JWJ76
61 gQ4fwLsknyXSV6sxYyhkDW4PEwwcTU06uqce0AAzXVffxne0fMe48x47+zqBgPbb
62 4huM+Pu8B9nfojUMr5TaYtl9Zbgpk3F8H7dT7LKOa6XrxvZTZrADSRc30+Z26zPN
63 e9zTaf42Gvt0/l0Zs1BHwbaOXqO+XuwJ3/F9Sf3PQYWXD3EOWjpHDP/X/1vAs6lV
64 SLkm6J/9KKE1m6I6LTYjIXuYt4SXybW6N2TSy54hhQtYcDUnIU2hR/PHVWKrGA0J
65 kELgrtTNTdbML27O5gFWU4PLUEYTZ9fN11D6qUZKxLcPOiPPHXkiILMRCCnG5DYI
66 ksBAU/YlAoGBAPxZO9VO18TYc8THV1nLKcvT2+1oSs1UcA2wNQMU55t910ZYinRa
67 MRwUhMOf8Mv5wOeiZaRICQB1PnVWtDVmGECgPpK6jUxqAwn8rgJcnoafLGL5YKMY
68 RVafTe6N5LXgCaOcJrk21wxs6v7ninEbUxxc575urOvZMBkymDw91dwbAoGBAPwa
69 YRhKhrzFKZzdK0RadVjnxKvolUllpoqqg3XuvmeAJHAOAnaOgVWq68NAcp5FZJv0
70 2D2Up7TX8pjf9MofP1SJbcraKBpK4NzfNkA0dSdEi+FhVofAJ9umB2o5LW1n7sab
71 UIrjsdzSJK/9Zb9yTTHPyibYzNEgaJV1HsbxfEFXAoGAYO2RmvRm0phll18OQVJV
72 IpKk9kLKAKZ/R/K32hAsikBC8SVPQTPniyaifFWx81diblalff2hX4ipTf7Yx24I
73 wMIMZuW7Im/R7QMef4+94G3Bad7p7JuE/qnAEHJ2OBnu+eYfxaK35XDsrq6XMazS
74 NqHE7hOq3giVfgg+C12hCKMCgYEAtu9dbYcG5owbehxzfRI2/OCRsjz/t1bv1seM
75 xVMND4XI6xb/apBWAZgZpIFrqrWoIBM3ptfsKipZe91ngBPUnL9s0Dolx452RVAj
76 yctHB8uRxWYgqDkjsxtzXf1HnZBBkBS8CUzYj+hdfuddoeKLaY3invXLCiV+PpXS
77 U4KAK9kCgYEAtSv0m5+Fg74BbAiFB6kCh11FYkW94YI6B/E2D/uVTD5dJhyEUFgZ
78 cWsudXjMki8734WSpMBqBp/J8wG3C9ZS6IpQD+U7UXA+roB7Qr+j4TqtWfM+87Rh
79 maOpG56uAyR0w5Z9BhwzA3VakibVk9KwDgZ29WtKFzuATLFnOtCS46E=
80 -----END RSA PRIVATE KEY-----
81 EOF
82 chmod 600 ${VIRL_PKEY}
83
84 #
85 # Pick a random host from the array of VIRL servers, and attempt
86 # to reach it and verify it's status.
87 #
88 # The server must be reachable, and have a "status" file with
89 # the content "PRODUCTION", to be selected.
90 #
91 # If the server is not reachable, or does not have the correct
92 # status, remove it from the array and start again.
93 #
94 # Abort if there are no more servers left in the array.
95 #
96 while [[ ! "$VIRL_SERVER" ]]
97 do
98     num_hosts=${#VIRL_SERVERS[@]}
99     if [ $num_hosts == 0 ]
100     then
101         echo "No more VIRL candidate hosts available, failing."
102         exit 127
103     fi
104     element=$[ $RANDOM % $num_hosts ]
105     virl_server_candidate=${VIRL_SERVERS[$element]}
106     virl_server_status=$(ssh ${SSH_OPTIONS} ${VIRL_USERNAME}@${virl_server_candidate} cat $VIRL_SERVER_STATUS_FILE 2>&1)
107     echo VIRL HOST $virl_server_candidate status is \"$virl_server_status\"
108     if [ "$virl_server_status" == "$VIRL_SERVER_EXPECTED_STATUS" ]
109     then
110         # Candidate is in good status. Select this server.
111         VIRL_SERVER="$virl_server_candidate"
112     else
113         # Candidate is in bad status. Remove from array.
114         VIRL_SERVERS=("${VIRL_SERVERS[@]:0:$element}" "${VIRL_SERVERS[@]:$[$element+1]}")
115     fi
116 done
117
118 # Temporarily download VPP and DPDK packages from nexus.fd.io
119 case "$DISTRO" in
120         CENTOS )
121             VPP_ARTIFACTS="vpp vpp-debuginfo vpp-devel vpp-lib vpp-plugins"
122             DPDK_ARTIFACTS=""
123             PACKAGE="rpm"
124             VPP_CLASSIFIER=""
125             DPDK_STABLE_VER=$(cat ${SCRIPT_DIR}/DPDK_STABLE_VER).x86_64
126             VPP_REPO_URL=$(cat ${SCRIPT_DIR}/VPP_REPO_URL_CENTOS)
127             VPP_STABLE_VER=$(cat ${SCRIPT_DIR}/VPP_STABLE_VER_CENTOS)
128             ;;
129         UBUNTU )
130             VPP_ARTIFACTS="vpp vpp-dbg vpp-dev vpp-lib vpp-plugins"
131             DPDK_ARTIFACTS="vpp-dpdk-dkms"
132             PACKAGE="deb"
133             VPP_CLASSIFIER="-deb"
134             DPDK_STABLE_VER=$(cat ${SCRIPT_DIR}/DPDK_STABLE_VER)_amd64
135             VPP_REPO_URL=$(cat ${SCRIPT_DIR}/VPP_REPO_URL_UBUNTU)
136             VPP_STABLE_VER=$(cat ${SCRIPT_DIR}/VPP_STABLE_VER_UBUNTU)
137 esac
138
139 if [ "${#}" -ne "0" ]; then
140     arr=(${@})
141     echo ${arr[0]}
142     # Download DPDK parts not included in dpdk plugin of vpp build
143     for ARTIFACT in ${DPDK_ARTIFACTS}; do
144         wget -q "${VPP_REPO_URL}/${ARTIFACT}/${DPDK_STABLE_VER}/${ARTIFACT}-${DPDK_STABLE_VER}${VPP_CLASSIFIER}.${PACKAGE}" || exit
145     done
146 else
147     rm -f *.${PACKAGE}
148     for ARTIFACT in ${DPDK_ARTIFACTS}; do
149         wget -q "${VPP_REPO_URL}/${ARTIFACT}/${DPDK_STABLE_VER}/${ARTIFACT}-${DPDK_STABLE_VER}${VPP_CLASSIFIER}.${PACKAGE}" || exit
150     done
151     for ARTIFACT in ${VPP_ARTIFACTS}; do
152         wget -q "${VPP_REPO_URL}/${ARTIFACT}/${VPP_STABLE_VER}/${ARTIFACT}-${VPP_STABLE_VER}${VPP_CLASSIFIER}.${PACKAGE}" || exit
153     done
154 fi
155
156 VPP_PKGS=(*.$PACKAGE)
157 echo ${VPP_PKGS[@]}
158 VIRL_DIR_LOC="/tmp"
159 VPP_PKGS_FULL=(${VPP_PKGS[@]})
160
161 # Prepend directory location at remote host to deb file list
162 for index in "${!VPP_PKGS_FULL[@]}"; do
163     VPP_PKGS_FULL[${index}]=${VIRL_DIR_LOC}/${VPP_PKGS_FULL[${index}]}
164 done
165
166 echo "Updated file names: " ${VPP_PKGS_FULL[@]}
167
168 # Copy the files to VIRL host
169 scp ${SSH_OPTIONS} *.${PACKAGE} \
170     ${VIRL_USERNAME}@${VIRL_SERVER}:${VIRL_DIR_LOC}/
171
172 result=$?
173 if [ "${result}" -ne "0" ]; then
174     echo "Failed to copy vpp deb files to virl host"
175     echo ${result}
176     exit ${result}
177 fi
178
179 # Start a simulation on VIRL server
180 echo "Starting simulation on VIRL server"
181
182 function stop_virl_simulation {
183     ssh ${SSH_OPTIONS} ${VIRL_USERNAME}@${VIRL_SERVER}\
184         "stop-testcase ${VIRL_SID}"
185 }
186
187 VIRL_SID=$(ssh ${SSH_OPTIONS} \
188     ${VIRL_USERNAME}@${VIRL_SERVER} \
189     "start-testcase -c ${VIRL_TOPOLOGY} -r ${VIRL_RELEASE} ${VPP_PKGS_FULL[@]}")
190 retval=$?
191 if [ ${retval} -ne "0" ]; then
192     echo "VIRL simulation start failed"
193     exit ${retval}
194 fi
195
196 if [[ ! "${VIRL_SID}" =~ session-[a-zA-Z0-9_]{6} ]]; then
197     echo "No VIRL session ID reported."
198     exit 127
199 fi
200
201 # Upon script exit, cleanup the simulation execution
202 trap stop_virl_simulation EXIT
203 echo ${VIRL_SID}
204
205 ssh_do ${VIRL_USERNAME}@${VIRL_SERVER} cat /scratch/${VIRL_SID}/topology.yaml
206
207 # Download the topology file from virl session
208 scp ${SSH_OPTIONS} \
209     ${VIRL_USERNAME}@${VIRL_SERVER}:/scratch/${VIRL_SID}/topology.yaml \
210     topologies/enabled/topology.yaml
211
212 retval=$?
213 if [ ${retval} -ne "0" ]; then
214     echo "Failed to copy topology file from VIRL simulation"
215     exit ${retval}
216 fi
217
218
219 virtualenv --system-site-packages env
220 . env/bin/activate
221
222 echo pip install
223 pip install -r ${SCRIPT_DIR}/requirements.txt
224
225 # There are used three iterations of tests there to check
226 # the stability and reliability of the results
227
228 RC=0
229 MORE_FAILS=0
230
231 for test_set in 1 2 3
232 do
233     echo
234     echo ${test_set}. test loop
235     PYTHONPATH=`pwd` pybot -L TRACE -W 136\
236         -v TOPOLOGY_PATH:${SCRIPT_DIR}/topologies/enabled/topology.yaml \
237         --suite "tests.func" \
238         --include vm_envAND3_node_single_link_topo \
239         --include vm_envAND3_node_double_link_topo \
240         --exclude PERFTEST \
241         --noncritical EXPECTED_FAILING \
242         --output log_test_set${test_set} \
243         tests/
244     PARTIAL_RC=$(echo $?)
245     if [ ${PARTIAL_RC} -eq 250 ]; then
246         MORE_FAILS=1
247     fi
248     RC=$((RC+PARTIAL_RC))
249 done
250
251 # Log the final result
252 if [ ${RC} -eq 0 ]; then
253     set +x
254     echo
255     echo "========================================================================================================================================"
256     echo "Final result of all test loops:                                                                                                 | PASS |"
257     echo "All critical tests have passed."
258     echo "========================================================================================================================================"
259     echo
260     set -x
261 elif [ ${MORE_FAILS} -eq 0 ]; then
262     if [ ${RC} -eq 1 ]; then
263         HLP_STR="test has"
264     else
265         HLP_STR="tests have"
266     fi
267     set +x
268     echo
269     echo "========================================================================================================================================"
270     echo "Final result of all test loops:                                                                                                 | FAIL |"
271     echo "${RC} critical ${HLP_STR} failed."
272     echo "========================================================================================================================================"
273     echo
274     set -x
275 else
276     set +x
277     echo
278     echo "========================================================================================================================================"
279     echo "Final result of all test loops:                                                                                                 | FAIL |"
280     echo "More then 250 critical tests have failed in one test loop."
281     echo "========================================================================================================================================"
282     echo
283     set -x
284 fi
285
286 echo Post-processing test data...
287
288 # Rebot output post-processing
289 rebot --noncritical EXPECTED_FAILING \
290       --output output.xml \
291       ./log_test_set1.xml ./log_test_set2.xml ./log_test_set3.xml
292
293 # Remove unnecessary log files
294 rm -f ./log_test_set1.xml ./log_test_set2.xml ./log_test_set3.xml
295
296 echo Post-processing finished.
297
298 if [ ${RC} -eq 0 ]; then
299     RETURN_STATUS=0
300 else
301     RETURN_STATUS=1
302 fi
303
304 exit ${RETURN_STATUS}

©2016 FD.io a Linux Foundation Collaborative Project. All Rights Reserved.
Linux Foundation is a registered trademark of The Linux Foundation. Linux is a registered trademark of Linus Torvalds.
Please see our privacy policy and terms of use.